UPD		EQU		$12		CRTC UPDATE REG #
CRS		EQU		$0E		CRTC UPDATA REG #
DIS		EQU		$0C		CRTC DIS STRT REG

RESET		EQU		$06
TOSADD		EQU		$08
CURLO		EQU		$09
CURHI		EQU		$0A
FILAD		EQU		$0B
ATTDAT		EQU		$0C
CHARACTER	EQU		$0D
MODREG		EQU		$0E

LEFTMGN		EQU		3			20
RIGHTMGN	EQU		4			80-32-20	




		ORG		$7D00

BASEADDR    FDB  $FF78
TIM         FCB  $80
CURX	    RMB	  1		CHARACTER COUNTER FOR PRINTER

START	LDU		BASEADDR
		LEAX	FORPAR,PCR
NA3		CLRB
LOOP1	LDD		,X++	STORE FORMAT
		STA		1,U
		STB		,U
		INCB
		CMPB	#6		ARE ALL VALUES STORED ?
		BCS		LOOP1
		LBSR	CLSCR

POINT	LDX		$0168
		STX		RTN1+1
NA5		LDX		$01A1
		STX		RTN2+1
NA6		LDX		$017A
		STX		RTN3+1
NA7		LEAX	ENTRY,PCR
NA1		LDA		$0167	REDIRECT BASIC
		STA		RTN1
NA8		LDA		$01A0
		STA		RTN2
NA9		LDA		$0179
		STA		RTN3
NB1		LDA		#$7E
		STA		$0167	HOOKS FOR OUTPUT
		STA		$01A0	PRINT, AND
* 		STA		$0179	CLEAR SCREEN
		NOP
		NOP
		NOP
		STX		$0168
		LEAX	CLEAR,PCR
NA2		STX		$01A1
		CLR		CURX
		RTS

ENTRY	PSHS	U,X,Y,A,B,CC	SAVE ALL REGS
        LDU     BASEADDR
		LDX		CURPOS
		LDB		$6F		PRINT TO WHAT DEVICE?
NB2		CMPb    #$03
     		beq     DONE
     		CMPA	#$8
		BNE		CHK1
		CMPX	0          ;LINPOS
NB3		BHI		BAKSP
		LDA		#$20
		BSR		PUT
		LBSR		MOVE
		BRA		DONE

BAKSP		LEAX	-1,X
		STX		CURPOS
		DEC		CURX
		PSHS		B,Y
		LDB		CURX	
		CMPB		#80-LEFTMGN-RIGHTMGN		
		BLS		BACKS2
		LDB		#80-LEFTMGN-RIGHTMGN-1
		STB		CURX
		LEAX	-LEFTMGN-RIGHTMGN,X
		STX		CURPOS
		LDY		LINPOS
		LEAY	-$50,Y
		STY		LINPOS
BACKS2		
		PULS		B,Y
NB4		BSR		MOVE2
		LDA		#$20
		BSR		PUT
		BSR		MOVE2
		BRA		DONE

CHK1	CMPA	#$0D
		BNE		CHK2
		BSR		NEWLINE
		BRA		DONE




CHK2	CMPA	#$20
		BCS		DONE
		BSR		PUT
		LEAX	1,X
		INC		CURX
		STX		CURPOS
NB8		LDX		LINPOS
NB9		LEAX	$50,X
		CMPX	CURPOS
NC1		BHI		FIN
		STX		LINPOS
NC2		BSR		SCROLL
FIN		BSR		MOVE
DONE	PULS	U,X,Y,A,B,CC
RTN1	FCB		00
		FDB		00

NEWLINE		
		LDX		LINPOS
NB5		LEAX	$50,X
		CLR	CURX
		STX		CURPOS
NB6		STX		LINPOS
NB7		LBSR	SCROLL
		BSR		MOVE2
		RTS


PUT		LDB		#CHARACTER
		STB		1,U
WAIT	LDB		1,U
		BPL		WAIT
		STA		,U
		RTS

GET		LDB		#CHARACTER
		STB		1,U
WAIT2	LDB		1,U
		BPL		WAIT2
		LDA		,U
		RTS

MOVE
 		LDB	CURX
 		CMPB	#80-LEFTMGN-RIGHTMGN
 		BLT	MOVE2
  		BSR	NEWLINE
MOVE2
		LDX		CURPOS
NC3		BSR		UPDCUR
		RTS

UPDREG	STA		1,U
		STB		,U
		RTS

UPDCUR	LDA		#CURHI
		STA		1,U
		TFR		X,D
		ADDD	TOPPOS
		CMPD	#2000
		BCS		NWRAP
		ADDD	#48
NWRAP
		ANDA	#$07
		STA		,U
		LDA		#CURLO
		BRA		UPDREG

UPDTOP	TFR		X,D
		LSRA
		RORB
		LSRA
		RORB
		LSRA
		RORB
		LSRA
		RORB
		LDA		#TOSADD
		ANDB	#$7F
		ORB     TIM
		BRA		UPDREG


SCROLL
		LDD		LINPOS
NC4		CMPD	#$0780-RIGHTMGN		;780-4
		BMI		RTRN

		LDD		#$50
		ADDD	TOPPOS
		CMPD	#2000-RIGHTMGN		;2000-4
		BMI		NOWRAP
		LDD		#0
NOWRAP	TFR		D,X
		STX		TOPPOS
		BSR		UPDTOP

		LDX		#$730+LEFTMGN            ;730+3 overscan
		STX		LINPOS
		STX		CURPOS
		BSR		UPDCUR
		LBSR	CLRLIN
RTRN	RTS


CLEAR	PSHS	U,X,Y,A,B,CC
        LDU     BASEADDR
		BSR		CLSCR
		PULS	U,X,Y,A,B,CC
RTN2	FCB		00
		FDB		00

PRINT	PSHS	U,X,Y,A,B,CC
        LDU     BASEADDR
		LDX		$A6
LUKAGN	LDA		,-X
		CMPA	#$87
		BEQ		NOMOVE
		CMPA	#$40
		BNE		LUKAGN
		LDA		#$50
		CLRB
		LDX		$88
		LEAX	-$400,X
LOOP4	CMPX	#$20
		BMI		NEWLOC
		INCB
		LEAX	-$20,X
		BRA		LOOP4
NEWLOC	MUL
		ADDD	#$2D0
		STD		LINPOS
NC9		LDD		TOPPOS
ND1		ADDD	LINPOS
ND2		STD		LINPOS
ND3		TFR		X,D
		LDX		LINPOS
ND4		ABX
		STX		CURPOS
ND5		LBSR	MOVE
NOMOVE	PULS	U,X,Y,A,B,CC
RTN3	FCB		00
		FDB		00

CLSCR	LDX		#LEFTMGN
		STX		LINPOS
		STX		CURPOS
		LDX		#0
		STX		TOPPOS
		LBSR	UPDTOP
		LBSR	UPDCUR
		LDD		#$0B80
		LBSR	UPDREG
		LDA		#$20
		LBSR	PUT
*		LBSR	MOVE
		RTS

CLRLIN	LDX		LINPOS
		LBSR	UPDCUR
		LDD		#$0E80
		LBSR	UPDREG
NE1		LEAX	$4F,X
RPT		LDA		#$20
		LBSR	PUT
		CMPX	LINPOS
NE2		BEQ		ENDLIN
		LEAX	-1,X
		DEC	CURX
		BRA		RPT
ENDLIN	LDD		#$0E00
		CLR CURX
		LBSR	UPDREG
		RTS

FORPAR	FDB		$0600	RESET
 
		FDB		$0E00	MODREG
		FDB		$0C01	ATTDAT
		FDB		$0880	TOSADD
		FDB		$0900	CURLO
		FDB		$0A00	CURHI


TOPPOS	FDB		$00
LINPOS	FDB		$00
CURPOS	FDB		$00
		END START



